Imports System.Math

Public Class MBmp
    Private Width As Integer
    Private Height As Integer
    Private RowWidth As Integer
    Private DataLen As Integer
    Private BmpData() As Byte

#Region "New"

    Public Sub New()
        Dim TBmpD(2) As Byte
        Me.Width = 1
        Me.Height = 1
        Me.RowWidth = Width * 3
        Me.DataLen = Height * Width * 3
        Me.BmpData = TBmpD
        TBmpD = Nothing
    End Sub

    Public Sub New(ByVal Width As Integer, ByVal Height As Integer)
        Me.Width = Width
        Me.Height = Height
        Me.RowWidth = Width * 3
        Me.DataLen = Me.Height * Width * 3
        Dim TBmpD(Me.DataLen - 1) As Byte
        Me.BmpData = TBmpD
        TBmpD = Nothing
    End Sub

    Public Sub New(ByVal Width As Integer, ByVal Height As Integer, ByVal BitmapColor As Color)
        Me.Width = Width
        Me.Height = Height
        Me.RowWidth = Width * 3
        Me.DataLen = Height * Width * 3
        Dim TBmpD(Me.DataLen - 1) As Byte
        Dim Tcolor(2) As Byte
        Tcolor(2) = BitmapColor.R
        Tcolor(0) = BitmapColor.B
        Tcolor(1) = BitmapColor.G
        For Y As Integer = 0 To Me.DataLen - 3 Step 3
            Array.Copy(Tcolor, 0, TBmpD, Y, 3)
        Next
        Me.BmpData = TBmpD
        TBmpD = Nothing
    End Sub

    Public Sub New(ByVal BitmapFile As String)
        'Check to make sure it exists
        Dim Tbm As New Bitmap(BitmapFile)
        Me.Width = Tbm.Width
        Me.Height = Tbm.Height
        Me.RowWidth = Width * 3
        Me.DataLen = Height * Width * 3
        Dim TBmp(Me.DataLen - 1) As Byte
        Dim X As Integer : Dim Y As Integer
        Dim CIndex As Integer = 0
        Dim TColor As Color

        If Int(Tbm.Width / 4) = Tbm.Width / 4 And Tbm.PixelFormat = Imaging.PixelFormat.Format24bppRgb _
            And Tbm.RawFormat.GetHashCode = -1102893738 Then
            ' Lock the bitmap data.
            LockBitmap(Tbm, MemRead)
            TBmp = g_PixBytes.Clone
            ' UnLock the bitmap data.
            UnlockBitmap(Tbm, MemRead)
        Else
            For Y = 0 To Me.Height - 1
                For X = 0 To Me.Width - 1
                    TColor = Tbm.GetPixel(X, Y)
                    TBmp(CIndex) = TColor.B
                    TBmp(CIndex + 1) = TColor.G
                    TBmp(CIndex + 2) = TColor.R
                    CIndex = CIndex + 3
                Next
            Next
        End If

        Me.BmpData = TBmp
        Tbm = Nothing
        TBmp = Nothing
    End Sub

    Public Sub New(ByVal BitmapFile As Bitmap)
        'Check to make sure it exists
        Me.Width = BitmapFile.Width
        Me.Height = BitmapFile.Height
        Me.RowWidth = Width * 3
        Me.DataLen = Me.Height * Width * 3
        Dim TBmp(Me.DataLen - 1) As Byte
        Dim X As Integer : Dim Y As Integer
        Dim CIndex As Integer = 0
        Dim TColor As Color

        If Int(BitmapFile.Width / 4) = BitmapFile.Width / 4 And BitmapFile.PixelFormat = Imaging.PixelFormat.Format24bppRgb _
            And BitmapFile.RawFormat.GetHashCode = -1102893738 Then
            ' Lock the bitmap data.
            LockBitmap(BitmapFile, MemRead)
            TBmp = g_PixBytes.Clone
            ' UnLock the bitmap data.
            UnlockBitmap(BitmapFile, MemRead)
        Else
            For Y = 0 To Me.Height - 1
                For X = 0 To Me.Width - 1
                    TColor = BitmapFile.GetPixel(X, Y)
                    TBmp(CIndex) = TColor.B
                    TBmp(CIndex + 1) = TColor.G
                    TBmp(CIndex + 2) = TColor.R
                    CIndex = CIndex + 3
                Next
            Next
        End If

        Me.BmpData = TBmp
        TBmp = Nothing
    End Sub

#End Region


    Public Function ConvertToBitmap()
        Dim Tbitmap As New Bitmap(Me.Width, Me.Height)
        If Int(Me.Width / 4) = Me.Width / 4 Then
            LockBitmap(Tbitmap, MemWrite)
            g_PixBytes = Me.BmpData  '.Clone
            UnlockBitmap(Tbitmap, MemWrite)
        Else
            Dim X As Integer : Dim Y As Integer
            Dim YIndex As Integer : Dim XIndex As Integer
            For Y = 0 To Me.Height - 1
                YIndex = 3 * Me.Width * Y
                For X = 0 To Me.Width - 1
                    XIndex = YIndex + (X * 3)
                    Tbitmap.SetPixel(X, Y, Color.FromArgb(Me.BmpData(XIndex + 2), Me.BmpData(XIndex + 1), Me.BmpData(XIndex)))
                Next
            Next
        End If
        ConvertToBitmap = Tbitmap
    End Function

    Public Sub FromBitmap(ByVal Image1 As Bitmap)
        Me.Height = Image1.Height
        Me.Width = Image1.Width
        Me.RowWidth = Width * 3
        Me.DataLen = Width * Height * 3
        Dim TBmpD(Me.DataLen - 1) As Byte

        If Int(Image1.Width / 4) = Image1.Width / 4 And Image1.PixelFormat = Imaging.PixelFormat.Format24bppRgb _
            And Image1.RawFormat.GetHashCode = -1102893738 Then
            LockBitmap(Image1, MemRead)
            TBmpD = g_PixBytes.Clone
            UnlockBitmap(Image1, MemRead)
        Else
            Dim X As Integer : Dim Y As Integer
            Dim YIndex As Integer : Dim XIndex As Integer
            Dim TColor As Color
            For Y = 0 To Me.Height - 1
                YIndex = 3 * Me.Width * Y
                For X = 0 To Me.Width - 1
                    XIndex = YIndex + (X * 3)
                    TColor = Image1.GetPixel(X, Y)
                    TBmpD(XIndex) = TColor.B
                    TBmpD(XIndex + 1) = TColor.G
                    TBmpD(XIndex + 2) = TColor.R
                Next
            Next
        End If
        Me.BmpData = TBmpD
    End Sub

    Public Function Crop(ByVal StartPoint As Point, ByVal EndPoint As Point)
        If StartPoint.X > EndPoint.X Or StartPoint.Y > EndPoint.Y Or StartPoint.X < 0 _
        Or StartPoint.Y < 0 Or EndPoint.X >= Me.Width Or EndPoint.Y >= Me.Height Then
            Dim TMBmp1 As New MBmp(0, 0)
            Return TMBmp1
        End If
        Dim Width As Integer = EndPoint.X - StartPoint.X + 1
        Dim Height As Integer = EndPoint.Y - StartPoint.Y + 1
        Dim TMBmp As New MBmp(Width, Height)
        Dim XOffset As Integer : Dim YOffset As Integer : Dim TYOffset As Integer
        Dim Y As Integer : Dim ArrayWidth As Integer = Width * 3


        For Y = 0 To Height - 1
            YOffset = (Y + StartPoint.Y) * Me.Width * 3 'me row offset
            TYOffset = Y * ArrayWidth 'tmbmp row offset
            XOffset = StartPoint.X * 3 + YOffset
            Array.Copy(Me.BmpData, XOffset, TMBmp.BmpData, TYOffset, ArrayWidth)
        Next

        Return TMBmp
    End Function

    Public Function Scale(ByVal Change As Single)
        If Me.Width < 1 Or Me.Height < 1 Or Change <= 0 Then Exit Function
        Dim Orig As Bitmap
        Orig = Me.ConvertToBitmap
        Dim bm_dest As New Bitmap(CInt(Me.Width * Change), CInt(Me.Height * Change))
        Dim gr_dest As Graphics = Graphics.FromImage(bm_dest)
        gr_dest.DrawImage(Orig, 0, 0, bm_dest.Width + 1, bm_dest.Height + 1)
        Dim SurfBMP As New MBmp(bm_dest)
        Orig = Nothing
        bm_dest = Nothing
        gr_dest = Nothing
        Return SurfBMP
    End Function

    Public Function Clone()
        Dim Dest As New MBmp(Me.GetWidth, Me.GetHeight)
        Dest.SetBMPData(Me.GetBMPData)
        Return Dest
        Dest = Nothing
    End Function

    Public Sub PasteOnTo(ByVal PastePoint As Point, ByVal OverLay As MBmp)
        Dim SPoint, EPoint As Point
        Dim SCrop, ECrop As Point
        SPoint.X = PastePoint.X - CInt(OverLay.Width / 2) : SPoint.Y = PastePoint.Y - CInt(OverLay.Height / 2)
        EPoint.X = SPoint.X + OverLay.Width - 1 : EPoint.Y = SPoint.Y + OverLay.Height - 1
        SCrop.X = 0 : SCrop.Y = 0 : ECrop.X = OverLay.Width - 1 : ECrop.Y = OverLay.Height - 1

        If SPoint.X >= Me.Width Or SPoint.Y >= Me.Height Or EPoint.X < 0 Or EPoint.Y < 0 Then Exit Sub

        'Crop
        If Me.Width < SPoint.X + OverLay.Width Then ECrop.X = Me.Width - 1 - SPoint.X
        If Me.Height < SPoint.Y + OverLay.Height Then ECrop.Y = Me.Height - 1 - SPoint.Y
        If SPoint.X < 0 Then
            SCrop.X = Abs(SPoint.X)
            SPoint.X = 0
        End If
        If SPoint.Y < 0 Then
            SCrop.Y = Abs(SPoint.Y)
            SPoint.Y = 0
        End If

        Dim OOffset, COffset, ArrayWidth As Integer
        ArrayWidth = (ECrop.X - SCrop.X + 1) * 3
        For Y As Integer = 0 To ECrop.Y - SCrop.Y
            OOffset = (Y + SPoint.Y) * (Me.Width * 3) + (SPoint.X * 3)
            COffset = (Y + SCrop.Y) * (OverLay.Width * 3) + (SCrop.X * 3)
            Array.Copy(OverLay.BmpData, COffset, Me.BmpData, OOffset, ArrayWidth)
        Next
    End Sub

    Public Sub PasteOnTo(ByRef PastePoint As Point, ByRef OverLay As VBMP, ByRef Direction As Integer)
        Dim CurPosMBmp As Integer = (PastePoint.Y * Me.RowWidth) + (PastePoint.X * 3)
        Dim CurRowMBmp As Integer = PastePoint.Y
        Dim CurPosVBMP As Integer
        Dim CurRowVBMP As Integer = 0
        If PastePoint.X < 0 Or PastePoint.X + OverLay.GetWidth > Me.Width Then
            Exit Sub
        End If
        If PastePoint.Y + OverLay.GetHeight <= 0 Or PastePoint.Y >= Me.Height Then
            Exit Sub
        End If
        If Direction = 0 Then 'normal

        ElseIf Direction = 1 Then  'reverse
        End If
    End Sub


#Region "Access Data"

    'Not Tested
    Public Function GetPixels(ByVal StartPoint As Point, ByVal EndPoint As Point)
        Dim ByteData(0) As Byte
        ByteData(0) = 0
        If StartPoint.X > EndPoint.X Or StartPoint.Y > EndPoint.Y Then
            MsgBox("The start point of MBmp select must be less then the end point.")
            Return ByteData
        End If
        If StartPoint.X < 0 Or EndPoint.X > Me.Width - 1 Or StartPoint.Y < 0 Or EndPoint.Y > Me.Height - 1 Then
            MsgBox("The selected area of the MBmp is not valid.")
            Return ByteData
        End If
        Dim LData As Integer
        LData = 3 * (Int(EndPoint.X) - Int(StartPoint.X) + 1) * (Int(EndPoint.Y) - Int(StartPoint.Y) + 1) - 1
        ReDim ByteData(LData)
        Dim Count As Integer = 0
        Dim YIndex As Integer
        For Y As Integer = Int(StartPoint.Y) To Int(EndPoint.Y)
            YIndex = Y * Me.Width * 3
            For X As Integer = 3 * Int(StartPoint.X) To 3 * Int(EndPoint.X) Step 3
                ByteData(Count) = Me.BmpData(YIndex + X)
                ByteData(Count + 1) = Me.BmpData(YIndex + X + 1)
                ByteData(Count + 2) = Me.BmpData(YIndex + X + 2)
                Count = Count + 3
            Next
        Next
        Return ByteData
    End Function

    Public Function GetBMPData()
        If Me.Height > 0 And Me.Width > 0 Then
            Return Me.BmpData.Clone
        End If
    End Function

    Public Function GetBMPDataRef()
        If Me.Height > 0 And Me.Width > 0 Then
            Return Me.BmpData
        End If
    End Function

    Public Function GetWidth()
        Return Me.Width
    End Function

    Public Function GetHeight()
        Return Me.Height
    End Function

    Public Function GetRowWidth()
        GetRowWidth = RowWidth
    End Function

    Public Function GetDataLen()
        Return Me.DataLen
    End Function

    Public Function SetBMPData(ByVal Data() As Byte)
        If UBound(Data, 1) = (Me.DataLen - 1) Then
            Me.BmpData = Data.Clone
        Else
            MsgBox("The data array given does not match the size of this MBmp.")
        End If
    End Function

    Public Function SetBMPDataRef(ByVal Data() As Byte)
        If UBound(Data, 1) = (Me.DataLen - 1) Then
            Me.BmpData = Data
        Else
            MsgBox("The data array given does not match the size of this MBmp.")
        End If
    End Function

#End Region

End Class

Public Class VBMP
    Private Width As Integer
    Private Height As Integer
    Private RowWidth As Integer
    Private DataLen As Integer
    Private VBMPData() As Byte

    'For use in the functions
    Private StartIndex As Integer
    Private SegLength As Integer
    'Data formate
    'StartPoint - Int
    'SegmentLength - Int
    'Data r,g,b,r,g,b,r,g,b all bytes

#Region "New"

    Public Sub New(ByVal VBMPFile As String)
        Dim FLen As Integer

        FileOpen(1, VBMPFile, OpenMode.Binary, OpenAccess.Read)
        Input(1, Width)
        Input(1, Height)
        Me.RowWidth = Width * 3
        Input(1, FLen)
        Me.DataLen = FLen - 12
        Dim TArray(DataLen - 1) As Byte
        Input(1, TArray)
        Me.VBMPData = TArray
        TArray = Nothing
    End Sub

#End Region

#Region "Access Data"

    Public Function GetVBMPDataRef()
        If Me.Height > 0 And Me.Width > 0 Then
            Return Me.VBMPData
        End If
    End Function

    Public Function GetWidth()
        Return Me.Width
    End Function

    Public Function GetHeight()
        Return Me.Height
    End Function

    Public Function GetRowWidth()
        GetRowWidth = RowWidth
    End Function

    Public Function GetDataLen()
        Return Me.DataLen
    End Function

#End Region

End Class
